<template>
    <b-card no-body>
        <b-card-header class="border-0">
            <h3 class="mb-0">List Table</h3>
        </b-card-header>
        <b-card-header class="border-0">
            <b-button @click="edit()">Create Data</b-button>
        </b-card-header>

        <el-table class="table-responsive table" header-row-class-name="thead-light" :data="data">
            <el-table-column label="Category" min-width="200px" prop="category">
                <template v-slot="{row}">
                    <b-media no-body class="align-items-center">
                        <b-media-body>
                            <span class="font-weight-600 category mb-0 text-sm">{{row.name}}</span>
                        </b-media-body>
                    </b-media>
                </template>
            </el-table-column>
            <el-table-column label="Parent" min-width="200px" prop="parent">
                <template v-slot="{row}">
                    <b-media no-body class="align-items-center">
                        <b-media-body>
                            <span v-if="row.parent_data" class="font-weight-600 parent mb-0 text-sm">{{row.parent_data.name}}</span>
                            <span v-else class="font-weight-600 parent mb-0 text-sm">-</span>
                        </b-media-body>
                    </b-media>
                </template>
            </el-table-column>
            <el-table-column label="Created" min-width="200px" prop="created">
                <template v-slot="{row}">
                    <b-media no-body class="align-items-center">
                        <b-media-body>
                            <span class="font-weight-600 created mb-0 text-sm">{{row.created_at}}</span>
                        </b-media-body>
                    </b-media>
                </template>
            </el-table-column>
            <el-table-column label="Action" min-width="200px" prop="action">
                <template v-slot="{row}">
                    <b-media no-body class="align-items-center">
                        <b-media-body>
                            <div class="btn-group">
                                <button class="btn btn-sm btn-primary" id="show-btn" @click="edit(row.id)">Edit</button>
                                <button class="btn btn-sm btn-danger" id="show-btn" @click="delete_data(row.id)">Delete</button>
                            </div>
                        </b-media-body>
                    </b-media>
                </template>
            </el-table-column>
        </el-table>


        <b-card-footer class="py-4 d-flex justify-content-end">
        </b-card-footer>

        <b-modal v-model="modalShow" class="modal modal-fixed-footer" title="Category" @ok="save()">
            <b-card-body>
                <form @submit="save()" ref="form">
                    <!-- <base-input v-model="dataModal.id" /> -->
                    <input type="hidden" :value="dataModal.id" >
                    <base-input label="Category Name" v-model="dataModal.name"  />

                    <base-input label="Parent">
                    <select class="form-control" v-model="dataModal.parent">
                        <option :value="null">-- Select --</option>
                        <option v-for="(item, index) in selectListCategory" :value="item.id" :key="index">{{item.name}}</option>
                    </select>
                    </base-input>
                </form>
            </b-card-body>
        </b-modal>

    </b-card>
</template>


<script>
    import { Table, TableColumn} from 'element-ui'
    //Bootstrap and jQuery libraries
    import 'bootstrap/dist/css/bootstrap.min.css';
    import 'jquery/dist/jquery.min.js';
    //Datatable Modules
    import "datatables.net-dt/js/dataTables.dataTables"
    import "datatables.net-dt/css/jquery.dataTables.min.css"
    import $ from 'jquery';
    import CategoryService from '../../service/admin/CategoryService'

  export default {
    name: 'light-table',
    components: {
      [Table.name]: Table,
      [TableColumn.name]: TableColumn,
    },
    data() {
      return {
        data:[],
        dataModal:{
            id : '',
            name : '',
            parent : '',
        },
        selectListCategory: [],
        modalShow: false,
        title: '',
        show: false

      };
    },
    methods: {
        get() {
            var params = [];
            var token = '';
            CategoryService.show(params, token)
            .then(response => {
                if (response.data.code == 200) {
                    this.data = response.data.data;
                }else{
                    this.$toastr.error(response.data.message);
                }
            })
        },
        save() {
                this.$swal({
                    title: "Store data?",
                    text: "Are you sure? You won't be able to revert this!",
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#3085d6",
                    confirmButtonText: "Yes, do it!",
                    closeOnConfirm: true
                    }).then((result) => {
                        if (result.isConfirmed) {
                            CategoryService.create(this.dataModal)
                            .then(response => {
                                if (response.data.code == 200) {
                                    this.$toastr.success(response.data.message);
                                }else{
                                    this.$toastr.error(response.data.message);
                                }
                                this.get()
                            })
                        }
                    })
        },
        edit(id) {
            CategoryService.show()
            .then(response => {
                this.selectListCategory = response.data.data
            })
            .catch(e => {
                this.isModalVisible = false;
                this.$toastr.error(e.message);
            });
            Object.assign(this.$data.dataModal, this.$options.data().dataModal)
            if (id != undefined) {
                var data = {id:id}
                CategoryService.show(data)
                .then(response => {
                    if (response.data.code == 200) {
                        this.dataModal = response.data.data[0]
                        this.title = 'Update Data'
                        this.modalShow = true
                    }else{
                        this.isModalVisible = false;
                        this.$toastr.error(response.data.message);
                    }
                })
            }else{
                this.title = 'Create Data'
                this.modalShow = true
            }
        },
        delete_data(id) {
            this.$swal({
                title: "Delete data?",
                    text: "Are you sure? You won't be able to revert this!",
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#3085d6",
                    confirmButtonText: "Yes, Delete it!",
                    closeOnConfirm: true
                    }).then((result) => {
                        if (result.isConfirmed) {
                            CategoryService.delete(id)
                            .then(response => {
                                if (response.data.code == 200) {
                                    this.$toastr.success(response.data.message);
                                }else{
                                    this.$toastr.error(response.data.message);
                                }
                                this.get()
                            })
                        }
                    })
        },
    },
    mounted () {
        this.get();
    }
  }
</script>
